"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.message
import typing
import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor = ...

class UnifiedAttestationAttributes(google.protobuf.message.Message):
    """/ UnifiedAttestationAttributes collect all attributes information
    / of trusted application from UnifiedAttestationReport format report.
    / All attributes is optional when used in UnifiedAttestationPolicy.
    / The TEE implement decides which attribute is used in repport and policy.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    STR_TEE_PLATFORM_FIELD_NUMBER: builtins.int
    HEX_PLATFORM_HW_VERSION_FIELD_NUMBER: builtins.int
    HEX_PLATFORM_SW_VERSION_FIELD_NUMBER: builtins.int
    HEX_SECURE_FLAGS_FIELD_NUMBER: builtins.int
    HEX_PLATFORM_MEASUREMENT_FIELD_NUMBER: builtins.int
    HEX_BOOT_MEASUREMENT_FIELD_NUMBER: builtins.int
    STR_TEE_IDENTITY_FIELD_NUMBER: builtins.int
    HEX_TA_MEASUREMENT_FIELD_NUMBER: builtins.int
    HEX_TA_DYN_MEASUREMENT_FIELD_NUMBER: builtins.int
    HEX_SIGNER_FIELD_NUMBER: builtins.int
    HEX_PROD_ID_FIELD_NUMBER: builtins.int
    STR_MIN_ISVSVN_FIELD_NUMBER: builtins.int
    BOOL_DEBUG_DISABLED_FIELD_NUMBER: builtins.int
    HEX_USER_DATA_FIELD_NUMBER: builtins.int
    HEX_HASH_OR_PEM_PUBKEY_FIELD_NUMBER: builtins.int
    HEX_NONCE_FIELD_NUMBER: builtins.int
    HEX_SPID_FIELD_NUMBER: builtins.int
    str_tee_platform: typing.Text = ...
    """The TEE platform, in case some verifier need to verify this."""

    hex_platform_hw_version: typing.Text = ...
    """The TEE platform hardware related identity or version"""

    hex_platform_sw_version: typing.Text = ...
    """The TEE platform TCB software related version"""

    hex_secure_flags: typing.Text = ...
    """The TEE platform security related attribte or flags"""

    hex_platform_measurement: typing.Text = ...
    """The measurement of TEE implement internal stuffs"""

    hex_boot_measurement: typing.Text = ...
    """The measurement of TEE instance boot time stuffs"""

    str_tee_identity: typing.Text = ...
    """The TEE instance or trust application identity when generate the reprot"""

    hex_ta_measurement: typing.Text = ...
    """The static measurement of trust application when load the code"""

    hex_ta_dyn_measurement: typing.Text = ...
    """The dynamical measurement of trust application code,
    for example, the real-time measurement of code in secure memory
    after the trust application is already run.
    """

    hex_signer: typing.Text = ...
    """The measurement or other identity of the trust application signer"""

    hex_prod_id: typing.Text = ...
    """The product ID of the TEE instance or trust application"""

    str_min_isvsvn: typing.Text = ...
    """The minimal ISV SVN of the TEE instance or trust application"""

    bool_debug_disabled: typing.Text = ...
    """The bool string "0" for debugable, "1" for not debugable"""

    hex_user_data: typing.Text = ...
    """The user special data for generating attestation report"""

    hex_hash_or_pem_pubkey: typing.Text = ...
    """hex string hash or original pem public key"""

    hex_nonce: typing.Text = ...
    """The idenpendent freshness value beside what in user data"""

    hex_spid: typing.Text = ...
    """The service provider id, e.g. use in sgx1, 64 bytes hex string"""

    def __init__(self,
        *,
        str_tee_platform : typing.Text = ...,
        hex_platform_hw_version : typing.Text = ...,
        hex_platform_sw_version : typing.Text = ...,
        hex_secure_flags : typing.Text = ...,
        hex_platform_measurement : typing.Text = ...,
        hex_boot_measurement : typing.Text = ...,
        str_tee_identity : typing.Text = ...,
        hex_ta_measurement : typing.Text = ...,
        hex_ta_dyn_measurement : typing.Text = ...,
        hex_signer : typing.Text = ...,
        hex_prod_id : typing.Text = ...,
        str_min_isvsvn : typing.Text = ...,
        bool_debug_disabled : typing.Text = ...,
        hex_user_data : typing.Text = ...,
        hex_hash_or_pem_pubkey : typing.Text = ...,
        hex_nonce : typing.Text = ...,
        hex_spid : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["bool_debug_disabled",b"bool_debug_disabled","hex_boot_measurement",b"hex_boot_measurement","hex_hash_or_pem_pubkey",b"hex_hash_or_pem_pubkey","hex_nonce",b"hex_nonce","hex_platform_hw_version",b"hex_platform_hw_version","hex_platform_measurement",b"hex_platform_measurement","hex_platform_sw_version",b"hex_platform_sw_version","hex_prod_id",b"hex_prod_id","hex_secure_flags",b"hex_secure_flags","hex_signer",b"hex_signer","hex_spid",b"hex_spid","hex_ta_dyn_measurement",b"hex_ta_dyn_measurement","hex_ta_measurement",b"hex_ta_measurement","hex_user_data",b"hex_user_data","str_min_isvsvn",b"str_min_isvsvn","str_tee_identity",b"str_tee_identity","str_tee_platform",b"str_tee_platform"]) -> None: ...
global___UnifiedAttestationAttributes = UnifiedAttestationAttributes

class UnifiedAttestationPolicy(google.protobuf.message.Message):
    """/ UnifiedAttestationPolicy is used when verify the attestation report.
    / Both main or nested submodule attester support multi-version of instances.
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    PEM_PUBLIC_KEY_FIELD_NUMBER: builtins.int
    MAIN_ATTRIBUTES_FIELD_NUMBER: builtins.int
    NESTED_POLICIES_FIELD_NUMBER: builtins.int
    pem_public_key: typing.Text = ...
    """Assume one public key is bound to one report, specify it here.
    We can also specify the public key or its hash in main or submodule
    UnifiedAttestationAttributes. Public key verification will happen
    in both two places.
    NOTE: if there is submodule attester, we must specify the public key
    here to verify the signature of submode attestation result.
    """

    @property
    def main_attributes(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___UnifiedAttestationAttributes]:
        """For main attester"""
        pass
    @property
    def nested_policies(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___UnifiedAttestationNestedPolicy]:
        """For submodule attesters"""
        pass
    def __init__(self,
        *,
        pem_public_key : typing.Text = ...,
        main_attributes : typing.Optional[typing.Iterable[global___UnifiedAttestationAttributes]] = ...,
        nested_policies : typing.Optional[typing.Iterable[global___UnifiedAttestationNestedPolicy]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["main_attributes",b"main_attributes","nested_policies",b"nested_policies","pem_public_key",b"pem_public_key"]) -> None: ...
global___UnifiedAttestationPolicy = UnifiedAttestationPolicy

class UnifiedAttestationNestedPolicy(google.protobuf.message.Message):
    """/ Match rulse for nested report verification"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    SUB_ATTRIBUTES_FIELD_NUMBER: builtins.int
    @property
    def sub_attributes(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___UnifiedAttestationAttributes]: ...
    def __init__(self,
        *,
        sub_attributes : typing.Optional[typing.Iterable[global___UnifiedAttestationAttributes]] = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["sub_attributes",b"sub_attributes"]) -> None: ...
global___UnifiedAttestationNestedPolicy = UnifiedAttestationNestedPolicy

class UnifiedAttestationReportParams(google.protobuf.message.Message):
    """/ Special Parameters for different TEE platforms, keep consistent with kubetee
    / attestation.proto
    """
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    STR_REPORT_IDENTITY_FIELD_NUMBER: builtins.int
    HEX_USER_DATA_FIELD_NUMBER: builtins.int
    JSON_NESTED_REPORTS_FIELD_NUMBER: builtins.int
    HEX_SPID_FIELD_NUMBER: builtins.int
    str_report_identity: typing.Text = ...
    """The identity string for report instance which is cached inside TEE.
    It's optional and usually used in Asynchronous processes.
    """

    hex_user_data: typing.Text = ...
    """The user data in some TEE platforms, Max to 64 Bytes of HEX string.
    Users need to convert binary value data to HEX string themselves.
    """

    json_nested_reports: typing.Text = ...
    """The JSON serialized string of UnifiedAttestationNestedReports"""

    hex_spid: typing.Text = ...
    """Service Provider ID for SGX1 only"""

    def __init__(self,
        *,
        str_report_identity : typing.Text = ...,
        hex_user_data : typing.Text = ...,
        json_nested_reports : typing.Text = ...,
        hex_spid : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["hex_spid",b"hex_spid","hex_user_data",b"hex_user_data","json_nested_reports",b"json_nested_reports","str_report_identity",b"str_report_identity"]) -> None: ...
global___UnifiedAttestationReportParams = UnifiedAttestationReportParams

class UnifiedAttestationReport(google.protobuf.message.Message):
    """/ Unified Attestation Report, keep consistent with kubetee attestation.proto"""
    DESCRIPTOR: google.protobuf.descriptor.Descriptor = ...
    STR_REPORT_VERSION_FIELD_NUMBER: builtins.int
    STR_REPORT_TYPE_FIELD_NUMBER: builtins.int
    STR_TEE_PLATFORM_FIELD_NUMBER: builtins.int
    JSON_REPORT_FIELD_NUMBER: builtins.int
    JSON_NESTED_REPORTS_FIELD_NUMBER: builtins.int
    str_report_version: typing.Text = ...
    """For compatibility and udpate later, current is version "1.0" """

    str_report_type: typing.Text = ...
    """Valid type string: "BackgroundCheck"|"Passport"|"Uas" """

    str_tee_platform: typing.Text = ...
    """The TEE platform name"""

    json_report: typing.Text = ...
    """Different JSON serialized string for each TEE platform
    The TEE platforms are in charge of parsing it in their own way.
    """

    json_nested_reports: typing.Text = ...
    """The JSON serialized string of UnifiedAttestationNestedReports"""

    def __init__(self,
        *,
        str_report_version : typing.Text = ...,
        str_report_type : typing.Text = ...,
        str_tee_platform : typing.Text = ...,
        json_report : typing.Text = ...,
        json_nested_reports : typing.Text = ...,
        ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["json_nested_reports",b"json_nested_reports","json_report",b"json_report","str_report_type",b"str_report_type","str_report_version",b"str_report_version","str_tee_platform",b"str_tee_platform"]) -> None: ...
global___UnifiedAttestationReport = UnifiedAttestationReport
